---
title: AVL tree analysis
nav_order: 9
---

Earlier, we used 1-1 correspondence with 2-3 trees to show that the height of an LLRB tree is guaranteed to be in *Θ*(log *N*) where *N* is the size of the tree. Let’s show that the height of an AVL tree is also in *O*(log *N*) using recurrence relations, unrolling, and asymptotic notation definitions.

This problem is not part of the learning objectives. It’s here to provide completeness to our study of balanced search trees since we showed earlier how 2-3 trees and LLRB trees have guaranteed logarithmic height.

Let *N* = *T*(*H*) represent the **minimum** number of elements stored in an AVL tree of height *H*. If we can show that an AVL tree must contain at least an exponential number of elements with respect to its height, then its height is logarithmic with respect to the size of the tree.

{% capture question %}
If the overall height of an AVL tree is *H*, one of its left/right children must be of height *H* − 1 for the 1 additional edge to the overall root. Which of the following expressions could represent the height of its other child?

- [ ] *H*
- [ ] *H* − 1
- [ ] *H* − 2
- [ ] *H* − 3
{% endcapture %}
{% include question.html question=question number=1 %}

{% capture question %}
Give a recurrence relation for *T*(*H*) that represents the most unbalanced AVL tree of height *H* in terms of its left and right subtrees: *T*(*H*) = *T*(*H* − 1) + *T*(?) + 1.
{% endcapture %}
{% include question.html question=question number=2 %}

{% capture question %}
Some of the following relations are true, and some of them are false. Among the relations that are true, identify the one relation that best addresses the central hypothesis: that an AVL tree must contain (at least) an exponential number of elements with respect to its height.

Note that we chose to drop the  + 1 to make the next step easier.

- [ ] *T*(*H*) ≥ 2*T*(*H* − 1)
- [ ] *T*(*H*) ≥ 2*T*(*H* − 2)
- [ ] *T*(*H*) ≤ 2*T*(*H* − 1)
- [ ] *T*(*H*) ≤ 2*T*(*H* − 2)
{% endcapture %}
{% include question.html question=question number=3 %}

{% capture question %}
Unroll the recurrence relation to show that *H* ∈ *O*(log *N*) for the most unbalanced AVL tree.

Instead of *T*(*H*), we typically use *N* to represent size. Note how we defined above that *N* = *T*(*H*).
{% endcapture %}
{% include question.html question=question number=4 %}
