---
title: AVL tree cases
nav_order: 3
---

AVL tree insertion is similar to the procedure that we saw with LLRB trees: first perform a regular BST insertion and then rebalance the tree using tree rotation operations wherever the balance factor is violated. After we insert a node, the balance factors change only for the nodes on the insertion path. Just like in LLRB trees, when **returning** from each recursive call to `add`, if the left and right subtree heights differ by more than 1, the AVL tree will perform tree rotations to restore balance, exactly like in an LLRB tree.

There are 4 different cases to consider for AVL tree insertion: 2 "line" cases and 2 "kink" cases. Try inserting values into the [AVL tree visualization](https://www.cs.usfca.edu/~galles/visualization/AVLtree.html) to see the rotations in action.

Line cases
: ![Line cases](https://docs.google.com/drawings/d/e/2PACX-1vT8Ve-1PD-IIZ6Ilk4qJ3J0Vrdw356ap7Lxixw0LTazanG0rOn3lUG1uecE34b5oAEQx5HsOkgSjM_G/pub?w=960&h=540)

Kink cases
: ![Kink cases](https://docs.google.com/drawings/d/e/2PACX-1vTRhA6QS-rYdNQiBrhL2ajWv9x1OpsB2DcBuc6AvzrpN7GTqJdEDvJKO-Am5qAqlpqX7qYStpAYtFhV/pub?w=960&h=540)

In order to check the balance factor, the AVL tree must know each subtree's height. Rather than recompute the subtree height every time, the code for an AVL tree nodes maintains the subtree height as a field. This is the same ideas storing the red/black node color in LLRB trees.
