---
title: AVL vs LLRB tree
nav_order: 7
---

Let's compare and contrast AVL trees with left-leaning red-black trees.

{% capture question %}
True/False: Consider this valid AVL tree. Is it possible to color some edges red so that it is a valid LLRB tree?

![Tree 3](https://docs.google.com/drawings/d/e/2PACX-1vSJ5CySZbAfdiSqB_kOeUX1pinGgeCLjmtV2AlshaGRWKjmYhn9ECwxK3DYh7pWPekCrI2QVbjbipoN/pub?w=384&h=216)
{% endcapture %}
{% capture explanation %}
In an LLRB tree, the value 2 would have been inserted as a red, right leaf node. But this would require a `rotateLeft(1)` so that we maintain the left-leaning property.
{% endcapture %}
{% include question.html question=question explanation=explanation number=1 %}

{% capture question %}
We know that worst-case search trees are as unbalanced as possible between the left and right subtrees. Are worst-case AVL trees more unbalanced than worst-case LLRB trees? Explain in terms of *H*, the height of the AVL or LLRB tree.

- [ ] Worst-case AVL trees are more unbalanced than worst-case LLRB trees.
- [ ] Worst-case LLRB trees are more unbalanced than worst-case AVL trees.
- [ ] Worst-case AVL trees are about as unbalanced as worst-case LLRB trees.
{% endcapture %}
{% capture explanation %}
Consider the worst-case subtree heights at the overall root:

- In an AVL tree, one subtree has height *H* − 1 and the other subtree has height *H* − 2.
- In an LLRB tree, the worst case occurs when the corresponding 2-3 tree has as many left-child 3-nodes as possibles. The left subtree of the overall root has height *H* − 1 and the right subtree has height approximately *H*/2 (since it lacks red edges).
{% endcapture %}
{% include question.html question=question explanation=explanation number=2 %}
