---
title: Tree representations
nav_order: 6
---

One of the main advantages of using heaps to implement priority queues is in the tree representation. We can represent trees in different ways.

Node representation
: Store items together with structure. Only parent to child references, so much harder to implement **swim**.

Array representation
: Store items separate from structure. If the tree is complete, both parent to child and child to parent indices can be computed for **sink** and **swim**.

<div style="--aspect-ratio: 720 / 405; --add-height: 29px"><iframe src="https://docs.google.com/presentation/d/e/2PACX-1vR9foCkz0NsxX0djuC8mNX0sqLS2TIErhNPkecZ4-ZGELgW-aqq8xuABi3gyifMh3GBKuvFEmTc0Q_Q/embed?start=false&loop=false&delayms=3000" frameborder="0" width="720" height="434" allowfullscreen="true" mozallowfullscreen="true" webkitallowfullscreen="true"></iframe></div>

In the real-world, binary heaps are never implemented using the node representation. When discussing "binary heaps" with other computer scientists, array representation is the default assumption.
