---
title: Left-leaning BST
nav_order: 2
---

Goal
: Develop a self-balancing binary search tree using the self-balancing property of 2-3 trees.

Note that 2-3 trees that only contain 2-nodes are already regular binary search trees! The challenge for us is to develop a binary tree representation for 3-nodes: nodes with left, middle, and right children.

Using an idea from rotation, we can separate a 3-node with the keys **B** and **D** into two nodes exactly as shown during the node rotation process. Each 3-node can be converted into two 2-nodes connected with a left-leaning "glue" edge. (In an alternate universe, we could have picked a right-leaning "glue" edge.)

Left-leaning binary search tree
: A binary search tree representation of a 2-3 tree where 3-nodes are represented as two 2-nodes connected with a left-leaning "glue" edge.

![Left-Leaning BSTs](https://docs.google.com/drawings/d/e/2PACX-1vQ67T0wIdv0OSjkBUsp8kHRWAx0udMHrg8G77KHZTExiF3LbFPs4Ay3nqfeWpsEc0dGItRrrzx67RRk/pub?w=960&h=540)

<div style="--aspect-ratio: 720 / 405; --add-height: 29px"><iframe src="https://docs.google.com/presentation/d/e/2PACX-1vTl2zOUnaGhELE38k29HpJOYXvYGiwKBl0XGE-fSyqIiR3qvcJOEwabqvYMEaLD_SlmNG0OMjHuhEGd/embed?start=false&loop=false&delayms=3000" frameborder="0" width="720" height="434" allowfullscreen="true" mozallowfullscreen="true" webkitallowfullscreen="true"></iframe></div>
