---
title: g0
nav_order: 10
---

Consider the following method. Assume `k(N)` runs in constant time and returns a boolean.

```java
static void g0(int N) {
    if (N == 0)
        return;
    g0(N / 2);
    if (k(N))
        g0(N / 2);
}
```

{% capture question %}
True/False: In the best-case runtime analysis for `g0`, `k(N)` always returns false.
{% endcapture %}
{% capture explanation %}
There are two factors that affect the runtime of `g0`: the value of `N` and the return value of `k(N)`.

Since we chose `N` as the asymptotic variable, that leaves the value of `k(N)` for case analysis. If `k(N)` always returns false, then each call to `g0` only makes one more recursive call to `g0`.
{% endcapture %}
{% include question.html question=question explanation=explanation number=1 %}

{% capture question %}
Identify the best-case order of growth for the runtime of `g0` with respect to `N`.

- [ ] *Θ*(1)
- [ ] *Θ*(log *N*)
- [ ] *Θ*(*N*)
- [ ] *Θ*(*N*log *N*)
- [ ] *Θ*(*N*<sup>2</sup>
- [ ] *Θ*(*N*<sup>2</sup>log *N*)
- [ ] *Θ*(*N*<sup>3</sup>)
{% endcapture %}
{% capture explanation %}
In the best case, `k(N)` always returns false so each recursive call only creates one more recursive call, so *T*(*N*) = *T*(*N*/2) + 1 ∈ *Θ*(log *N*).
{% endcapture %}
{% include question.html question=question explanation=explanation number=2 %}

{% capture question %}
Identify the worst-case order of growth for the runtime of `g0` with respect to `N`.

- [ ] *Θ*(1)
- [ ] *Θ*(log *N*)
- [ ] *Θ*(*N*)
- [ ] *Θ*(*N*log *N*)
- [ ] *Θ*(*N*<sup>2</sup>
- [ ] *Θ*(*N*<sup>2</sup>log *N*)
- [ ] *Θ*(*N*<sup>3</sup>)
{% endcapture %}
{% capture explanation %}
In the worst case, `k(N)` always returns true so each recursive call creates two more recursive calls, so *T*(*N*) = 2*T*(*N*/2) + 1 ∈ *Θ*(*N*).
{% endcapture %}
{% include question.html question=question explanation=explanation number=3 %}
