---
title: help
nav_order: 11
---

Consider the following method.

```java
static int help(int N) {
    if (N < 1000) {
        for (int i = 0; i < N * N * N; i += 1)
            System.out.print("be");
        return x;
    } else {
        for (int i = 0; i < N / 2; i += 1)
            System.out.print("be");
        return 2 * help(N / 2);
    }
}
```

{% capture question %}
True/False: In the best-case runtime analysis for `help`, `N` is less than 1000.
{% endcapture %}
{% capture explanation %}
There's only one factor that affects the runtime of the program: the value of `N`. Since we chose to perform asymptotic analysis with `N` as the asymptotic variable, `N` must be very large: "for all values of *N* greater than *N*<sub>0</sub>."

It's also problematic to discuss case analysis for this problem since there was only one factor that can affect the program's runtime. Since we already chose that factor as the asymptotic variable, there are no other factors to vary for best/worst case analysis.
{% endcapture %}
{% include question.html question=question explanation=explanation number=1 %}

{% capture question %}
Give the order of growth for the runtime of `help` with respect to `N`.

- [ ] *Θ*(1)
- [ ] *Θ*(log *N*)
- [ ] *Θ*(*N*)
- [ ] *Θ*(*N*log *N*)
- [ ] *Θ*(*N*<sup>2</sup>
- [ ] *Θ*(*N*<sup>2</sup>log *N*)
- [ ] *Θ*(*N*<sup>3</sup>)
- [ ] *Θ*(2<sup>*N*</sup>)
{% endcapture %}
{% capture explanation %}
A recurrence relation that describes the runtime of help is *T*(*N*) = *T*(*N*/2) + *N*.
{% endcapture %}
{% include question.html question=question explanation=explanation number=2 %}
